[![Build Status](http://img.shields.io/travis/0x01f7/mahoujin.svg)](https://travis-ci.org/0x01f7/mahoujin)
[![Dependency Status](http://img.shields.io/gemnasium/0x01f7/mahoujin.svg)](https://gemnasium.com/0x01f7/mahoujin)
[![Test Coverage](https://img.shields.io/codeclimate/coverage/github/0x01f7/mahoujin.svg)](https://codeclimate.com/github/0x01f7/mahoujin/coverage)
[![Code Climate](http://img.shields.io/codeclimate/github/0x01f7/mahoujin.svg)](https://codeclimate.com/github/0x01f7/mahoujin)
[![Gem Version](http://img.shields.io/gem/v/mahoujin.svg)](https://rubygems.org/gems/mahoujin)
[![License](http://img.shields.io/:license-mit-blue.svg)](http://0x01f7.mit-license.org)


# Mahoujin

Generate syntax diagram(aka railroad diagram) from EBNF specification


## Requirements

* [Cairo](http://cairographics.org) >= 1.12.0
* [Ruby](https://www.ruby-lang.org) >= 2.0.0


## Installation

* Use Ruby's package manager

    ```Text
    $ gem install mahoujin
    ```

* Or from source

    ```Text
    $ git clone https://github.com/0x01f7/mahoujin.git
    $ cd mahoujin
    $ ./bin/setup
    $ ./bin/rake install
    ```


## Usage

Run command:

```
$ mahoujin SYNTAX.ebnfspec -o SYNTAX.png
```

Note: the **SYNTAX.ebnfspec** uses **EBNF** which is defined in [ISO/IEC 14977](https://www.cl.cam.ac.uk/~mgk25/iso-14977.pdf) to describe it's rules.


## Samples - EBNF

**SYNTAX.ebnfspec**:

```Text
           syntax = syntax rule, {syntax rule};
      syntax rule = meta identifier, '=', definitions list, ';';
 definitions list = single definition, {'|', single definition};
single definition = term, {',', term};
             term = factor, ['-', exception];
        exception = factor;
           factor = [integer, '*'], primary;
          primary = optional sequence | repeated sequence
                  | grouped sequence | special sequence
                  | meta identifier | terminal string;
optional sequence = '[', definitions list, ']';
repeated sequence = '{', definitions list, '}';
 grouped sequence = '(', definitions list, ')';
 special sequence = '?', {character - '?'}, '?';
  meta identifier = letter, {letter | decimal digit | ? ASCII space character ?};
  terminal string = "'", character - "'", {character - "'"}, "'"
                  | '"', character - '"', {character - '"'}, '"';
          integer = decimal digit, {decimal digit};
        character = ? any character in ASCII alphabet characters ?;
    decimal digit = ? any character in ASCII number characters ?;
```

**SYNTAX.png**:

![SYNTAX.png](https://raw.githubusercontent.com/0x01f7/mahoujin/master/samples/ebnf/syntax.png)
